<?php
/*
 * JEZ Arguo Joomla! 1.5 Module
 *
 * @package		Module Helpers
 * @version		1.0.0
 * @author		JoomlaEZ.com
 * @copyright	Copyright (C) 2008 JoomlaEZ.com. All rights reserved
 * @license		Commercial Proprietary
 *
 * Please visit http://joomlaez.com/ for more information
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modJezNewsflasherHelper {
	// function to render content item
	function renderItem(&$item, &$params, &$access) {
		global $mainframe;

		$user =& JFactory::getUser();

		if ( !in_array($params->get('source'), array('newsfeeds', 'modules', 'xml')) ) {
			$item->text = $params->get('intro_only') ? $item->introtext : $item->introtext."\n".$item->fulltext;
			$item->readmore = ($params->get('intro_only') && $params->get('readmore') && trim($item->fulltext) != '');

			if ($params->get('intro_only') && ($params->get('readmore') || $params->get('link_titles'))) {
				// check if user has permission to view the full article or not
				if ($item->access <= (int) $user->get('aid', 0))
					$item->linkOn = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, (isset($item->catslug) ? $item->catslug : ''), $item->sectionid));
				else {
					$item->linkOn = JRoute::_('index.php?option=com_user&task=register');
					$item->linkText = JText::_('Login to read more...');
				}
			}

			if ( !$params->get('intro_only') ) {
				$results = $mainframe->triggerEvent('onAfterDisplayTitle', array(&$item, &$params, 1));
				$item->afterDisplayTitle = trim(implode("\n", $results));
			}

			$results = $mainframe->triggerEvent('onBeforeDisplayContent', array(&$item, &$params, 1));
			$item->beforeDisplayContent = trim(implode("\n", $results));
		}

		// let Joomla! route URL embeded inside content text
		if (preg_match_all('#<a\s+[^>]*href="([^"^>]+)"[^>]*>#si', $item->text, $matches, PREG_SET_ORDER) > 0) {
			foreach ($matches AS $match) {
				if (!preg_match('#^(http|https)://#i', $match[1]))
					$item->text = str_replace($match[0], str_replace($match[1], JRoute::_($match[1]), $match[0]), $item->text);
			}
		}

		if (!$params->get('image')) // strip images out of item content
			$item->text = preg_replace( '/<img[^>]*>/', '', $item->text);

		if ($params->get('words')) // truncate item content to number of words specified
			$item->text = modJezNewsflasherHelper::getWords($item->text, $params->get('words'));

		require(JModuleHelper::getLayoutPath('mod_JEZ_Arguo', '_item'));
	}

	// function to retrieve contents from specified source
	function getList(&$params, &$access) {
		global $mainframe;

		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$aid = (int) $user->get('aid', 0);

		$ids = explode(',', $params->get('sourceid'));
		for ($i = 0; $i < count($ids); $i++)
			$ids[$i] = (int) trim($ids[$i]);
		$ids = implode(',', $ids);
		$items = (int) $params->get('items');

		$rows = array();
		if ( !in_array($params->get('source'), array('newsfeeds', 'modules', 'xml')) ) {
			$contentConfig =& JComponentHelper::getParams('com_content');
			$noauth = !$contentConfig->get('shownoauth');

			$date =& JFactory::getDate();
			$now = $date->toMySQL();
			$nullDate = $db->getNullDate();

			// internal articles, create appropriate query for selected data source
			switch ($params->get('source')) {
				case 'section':
					$select = ', CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug';
					$joins = ' LEFT JOIN #__categories AS cc ON cc.id = a.catid'
					. ' LEFT JOIN #__sections AS s ON s.id = a.sectionid';
					$where = ' a.sectionid IN ('.$ids.')'
					. ' AND cc.section = s.id'
					. ($noauth ? ' AND cc.access <= '.$aid.' AND s.access <= '.$aid : '')
					. ($params->get('show_unpublished') ? '' : ' AND a.state = 1 AND cc.published = 1 AND s.published = 1');
					break;
				case 'category':
					$select = ', CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug';
					$joins = ' LEFT JOIN #__categories AS cc ON cc.id = a.catid';
					$where = ' a.catid IN ('.$ids.')'
					. ($noauth ? ' AND cc.access <= '.$aid : '')
					. ($params->get('show_unpublished') ? '' : ' AND a.state = 1 AND cc.published = 1');
					break;
				case 'archive':
					$select = '';
					$joins = '';
					$where = ' a.state = -1';
					break;
				case 'articles':
					$select = '';
					$joins = '';
					$where = ' a.id IN ('.$ids.')' . ($params->get('show_unpublished') ? '' : ' AND a.state = 1'
					. ' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).')'
					. ' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).')');
					break;
				case 'frontpage':
				default:
					$select = '';
					$joins = ' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id';
					$where = ($params->get('show_unpublished') ? '' : ' a.state = 1'
					. ' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).')'
					. ' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).')');
					break;
			}

			// prepare order control
			switch ($params->get('orderby')) {
				case 'random':
					$orderby = ' ORDER BY RAND()';
					break;
				case 'date':
					$orderby = ' ORDER BY a.created';
					break;
				case 'rdate':
					$orderby = ' ORDER BY a.created DESC';
					break;
				case 'alpha':
					$orderby = ' ORDER BY a.title';
					break;
				case 'ralpha':
					$orderby = ' ORDER BY a.title DESC';
					break;
				case 'hits':
					$orderby = ' ORDER BY a.hits DESC';
					break;
				case 'rhits':
					$orderby = ' ORDER BY a.hits ASC';
					break;
				case 'noorder':
					$orderby = '';
					break;
				case 'ordering':
				default:
					if ($params->get('source') == 'section')
						$orderby = ' ORDER BY s.ordering, cc.ordering, a.ordering';
					else if ($params->get('source') == 'category')
						$orderby = ' ORDER BY cc.ordering, a.ordering';
					else
						$orderby = ' ORDER BY a.ordering';
					break;
			}

			// query for articles
			$query = 'SELECT a.*,'
			. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug'
			. $select . ' FROM #__content AS a' . $joins . ' WHERE' . $where
			. ($noauth ? ($where != '' ? ' AND' : '').' a.access <= '.$aid : '')
			. $orderby;

			// let's query for articles now
			if ($items > 0)
				$db->setQuery($query, 0, $items);
			else
				$db->setQuery($query);
			$rows = $db->loadObjectList();
		} elseif ($params->get('source') == 'newsfeeds') {
			// external articles, get link from specified news feeds
			$query = 'SELECT f.*,'
			. ' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(\':\', cc.id, cc.alias) ELSE cc.id END as catslug'
			. ' FROM #__newsfeeds AS f'
			. ' LEFT JOIN #__categories AS cc ON cc.id = f.catid'
			. ' WHERE f.id IN ('.$ids.')'
			. ($params->get('show_unpublished') ? '' : ' AND f.published = 1 AND cc.published = 1')
			. ' AND cc.access <= '.$aid;
			$db->setQuery($query);
			$newsfeeds = $db->loadObjectList();

			// get data from queried news feeds links
			foreach ($newsfeeds AS $newsfeed) {
				$options['rssUrl'] = $newsfeed->link;
				$options['cache_time'] = $newsfeed->cache_time;

				$rssDoc =& JFactory::getXMLparser('RSS', $options);
				if ($rssDoc == false)
					continue;
				else {
					$newsfeed->items = $rssDoc->get_items();
					if (!count($newsfeed->items))
						continue;
				}

				// is limitation specified?
				if ($items > 0) {
					$limit = $items - count($rows);
					if ($limit == 0)
						break;
					else
						$newsfeed->items = array_slice($newsfeed->items, 0, $limit);
				}

				// parse and store feeded items
				foreach ($newsfeed->items AS $item) {
					$row = new stdClass();

					// create link to read full article
					if (!is_null($item->get_link()) && ($params->get('readmore') || $params->get('link_titles')))
						$row->linkOn = JRoute::_( $item->get_link() ).'" target="_blank';

					// store syndicated title and content
					$row->title = str_replace('&apos;', "'", $item->get_title());
					$row->text = str_replace('&apos;', "'", $item->get_description());

					$rows[] = $row;
				}
			}
		} elseif ($params->get('source') == 'modules') {
			// prepare order control for modules query
			switch ($params->get('orderby')) {
				case 'random':
					$orderby = ' ORDER BY RAND()';
					break;
				case 'alpha':
					$orderby = ' ORDER BY title';
					break;
				case 'ralpha':
					$orderby = ' ORDER BY title DESC';
					break;
				case 'noorder':
					$orderby = '';
					break;
				case 'ordering':
				default:
					$orderby = ' ORDER BY ordering';
					break;
			}

			// query for modules
			$query = 'SELECT * FROM #__modules'
			. ' WHERE id IN ('.$ids.')'.($params->get('show_unpublished') ? '' : ' AND published = 1')
			. ' AND access <= '.$aid
			. ' AND client_id = '. (int)$mainframe->getClientId()
			. $orderby;

			// let's query for modules now
			if ($items > 0)
				$db->setQuery($query, 0, $items);
			else
				$db->setQuery($query);
			$mods = $db->loadObjectList();

			// if we have result, render and store queried modules
			if ($mods) {
				foreach ($mods AS $mod) {
					// is this a custom HTML module?
					if ( !isset($mod->user) )
						$mod->user = $mod->module == 'mod_custom' ? 1 : 0;

					$row = new stdClass();
					$row->text = JModuleHelper::renderModule($mod);

					// get module title
					if ($params->get('module_title') == 1 || ($params->get('module_title') == -1 && $mod->showtitle))
						$row->title = $mod->title;

					$rows[] = $row;
				}
			}
		} elseif ($params->get('sourceid') != '') {
			// init XML parser
			$xmlDoc =& JFactory::getXMLparser();
			$xmlDoc->resolveErrors(true);

			if (substr($params->get('sourceid'), 0, 5) == 'http:') {
				// enable parsing for remote XML document
				$xmlDoc->useHTTPClient(true);
			} elseif (!preg_match('/^(\/|[a-zA-Z]:)/', $params->get('sourceid'))) {
				// convert XML document's relative path to absolute path
				$params->set('sourceid', JPATH_SITE.DS.$params->get('sourceid'));
			}

			if (substr($params->get('sourceid'), 0, 5) != 'http:' && !file_exists($params->get('sourceid')))
				return;

			// get XML data
			if ($params->get('utf8xml'))
				$success = $xmlDoc->loadXML_utf8($params->get('sourceid'));
			else
				$success = $xmlDoc->loadXML($params->get('sourceid'));

			if (!$success || !is_object($xmlDoc->documentElement)) {
				// free up memory from DOMIT parser
				unset($xmlDoc);
				return;
			}

			// get slideshow items from XML document
			$xmlItems = $xmlDoc->getElementsByTagName(trim($params->get('item_node')));
			unset($xmlDoc);

			// parse and store slideshow items
			for ($i = 0, $n = $xmlItems->getLength(); $i < $n; $i++) {
				$item =& $xmlItems->item($i);
				$row = new stdClass();

				// get item title
				$tmp = $item->getElementsByTagName(trim($params->get('item_title_node')));
				if ($tmp->getLength())
					$row->title = $tmp->item(0)->getText();
				else {
					// try to get item's title from the item node's attributes
					if ($item->hasAttribute(trim($params->get('item_title_node'))))
						$row->title = $item->getAttribute(trim($params->get('item_title_node')));
				}

				// get item content
				$tmp = $item->getElementsByTagName(trim($params->get('item_content_node')));
				if ($tmp->getLength())
					$row->text = $tmp->item(0)->getText();
				else {
					// try to get item's content from the item node's attributes
					if ($item->hasAttribute(trim($params->get('item_content_node'))))
						$row->text = $item->getAttribute(trim($params->get('item_content_node')));
					else
						$row->text = '';
				}

				// get item associated link
				$tmp = $item->getElementsByTagName(trim($params->get('item_link_node')));
				if ($tmp->getLength())
					$row->linkOn = $tmp->item(0)->getText();
				else {
					// try to get item's associated link from the item node's attributes
					if ($item->hasAttribute(trim($params->get('item_link_node'))))
						$row->linkOn = $item->getAttribute(trim($params->get('item_link_node')));
				}

				// fix an unknown bug of the XML parser
				if (isset($row->title) && preg_match('/http\//', $row->title))
					$row->title = str_replace('http/', '/', $row->title);
				if ($row->text != '' && preg_match('/http\//', $row->text))
					$row->text = str_replace('http/', '/', $row->text);
				if (isset($row->linkOn) && preg_match('/http\//', $row->linkOn))
					$row->linkOn = JRoute::_( str_replace('http/', '/', $row->linkOn) );

				$rows[] = $row;
				if ($items > 0 && count($rows) >= $items)
					break;
			}
		}

		return $rows;
	}

	// function to truncate given content to specified words
	function getWords($text, $count) {
		$words = preg_split("/[\s\t\n]+/", str_replace('><', ">\n<", $text));

		if (count($words) > $count) {
			$i = 0;
			$openTag = array();
			$counting = 0;
			$text = '';

			while ($counting < $count && $i < count($words)) {
				$text .= ($text == '' ? '' : ' ').$words[$i];

				if (preg_match("/^.*<\/[^>]+>.*$/", $words[$i])) {
					// found close tag, e.g. </b>, </i>, </strong>, </em>
					array_pop($openTag);

					// increase words count also if the close tag is prefixed or suffixed with any word
					if (strpos($words[$i], '<') > 0 || strpos($words[$i], '>') < (strlen($words[$i]) - 1))
						$counting++;
				} elseif (preg_match("/^.*<[^>]+>.*$/", $words[$i])) {
					// found a single word open tag, e.g. <b>, <i>, <strong>, <em>
					$openTag[] = $words[$i];

					// found self-closed tag, e.g. <br/>
					if (preg_match("/^.*<[^\/^>]+\/>.*$/", $words[$i]))
						array_pop($openTag);

					// increase words count also if the open / self-closed tag is prefixed or suffixed with any word
					if (strpos($words[$i], '<') > 0 || strpos($words[$i], '>') < (strlen($words[$i]) - 1))
						$counting++;
				} elseif (preg_match("/^.*<[^\/^>]+$/", $words[$i])) {
					// found starting part of multi-words open tag, e.g. <a, <table
					$openTag[] = $words[$i];

					// increase words count also if the open tag is prefixed with any word
					if (strpos($words[$i], '<') > 0)
						$counting++;

					// get all remaining parts of the tag
					do {
						$i++;
						$text .= ' '.$words[$i];
					} while (!preg_match("/^.*>.*$/", $words[$i]));

					// increase words count if the final part of the tag is suffixed with any word
					if (strpos($words[$i], '>') < (strlen($words[$i]) - 1))
						$counting++;

					// found self-closed tag or the final part of the tag also contains close tag
					if (preg_match("/^.*\/>.*$/", $words[$i]) || preg_match("/^.*<\/[^>]+>.*$/", $words[$i]))
						array_pop($openTag);
				} else {
					// not a tag, increase words count
					$counting++;
				}

				$i++;
			}

			// complete the truncated text
			$text .= $i < count($words) ? '...' : '';

			if (count($openTag)) {
				// the truncated text has tag(s) that is/are not closed, close now
				for ($i = count($openTag) - 1; $i >= 0; $i--)
					$text .= '</'.preg_replace("/(.*<)|(>.*)/", '', $openTag[$i]).'>';
			}
		}

		return $text;
	}

	// function to load required or specified scripts
	function loadScripts($scripts = null, $path = 'modules/mod_JEZ_Arguo/', $matchExactPath = false) {
		if (!isset($scripts) || empty($scripts))
			$scripts = array('mootools.js', 'jezBaseFx.js', 'jezSlideshow.js', 'jezTextShow.js');
		elseif (!is_array($scripts))
			$scripts = array($scripts);

		// get document head and body
		$document = &JFactory::getDocument();
		$head = $document->getHeadData();
		$body = JResponse::getBody();
		$base = JURI::base(true);

		// if any script is already loaded, ignore it
		foreach ($scripts AS $script) {
			$loaded = false;
			foreach ($head['scripts'] AS $k => $v) {
				if (preg_match('#'.str_replace('.', '\\.', ($matchExactPath ? $path : '').$script).'$#', $k)) {
					$loaded = true;
					break;
				}
			}
			if (!$loaded) {
				if (empty($body)) {
					if ($script == 'mootools.js')
						JHTML::_('behavior.mootools');
					else
						JHTML::_('script', $script, $path);
				} else {
					if ($script == 'mootools')
						echo '<script type="text/javascript" src="'.$base.'/media/system/js/mootools.js"></script>';
					else
						echo '<script type="text/javascript" src="'.$base.'/'.$path.$script.'"></script>';
				}
			}
		}
	}

	// function to load required or specified stylesheets
	function loadStylesheets($stylesheets = null, $path = 'modules/mod_JEZ_Arguo/tmpl/', $matchExactPath = true) {
		if (!isset($stylesheets) || empty($stylesheets))
			$stylesheets = array('default.css');
		elseif (!is_array($stylesheets))
			$stylesheets = array($stylesheets);

		// get document head and body
		$document = &JFactory::getDocument();
		$head = $document->getHeadData();
		$body = JResponse::getBody();
		$base = JURI::base(true);

		// if any stylesheet is already loaded, ignore it
		foreach ($stylesheets AS $stylesheet) {
			$loaded = false;
			foreach ($head['styleSheets'] AS $k => $v) {
				if (preg_match('#'.str_replace('.', '\\.', ($matchExactPath ? $path : '').$stylesheet).'$#', $k)) {
					$loaded = true;
					break;
				}
			}
			if (!$loaded) {
				if (empty($body))
					JHTML::_('stylesheet', $stylesheet, $path);
				else
					echo '<link rel="stylesheet" href="'.$base.'/'.$path.$stylesheet.'" type="text/css" />';
			}
		}
	}
}

echo '
<noscript>
<p><a href="http://joomlaez.com/extensions/slideshow-joomla-module-to-create-web-20-joomla-slideshow.html" title="JoomlaEZ.com\'s Joomla Slideshow Module">Slideshow created by JoomlaEZ.com\'s Joomla Slideshow Module, a Joomla module developed by JoomlaEZ.com supports creating modern web 2.0 slideshow layouts in minutes.</a></p>
</noscript>
';
?>